declare('quickreply', {})
quickreply.channel = gkini.ReadInt("QuickReply", "channel", 1)
quickreply.version = '1.1'

local last_chat_name = nil
local last_sector_name = nil
local recent_channel = nil

function quickreply:OnEvent(event, data)
	if event == "CHAT_MSG_CHANNEL" or event == "CHAT_MSG_CHANNEL_EMOTE" then
		recent_channel = data.channelid
		if data.channelid == quickreply.channel then last_chat_name = data.name end
	elseif event == "CHAT_MSG_CHANNEL_ACTIVE" or event == "CHAT_MSG_CHANNEL_ACTIVE_EMOTE" then
		if data.channelid == quickreply.channel and data.name ~= GetPlayerName() then last_chat_name = data.name end
	elseif event == "CHAT_MSG_SECTOR" or event == "CHAT_MSG_SECTOR_EMOTE" then
		if data.name ~= GetPlayerName() then last_sector_name = data.name end
	end
end

function quickreply:replytarget()
	gkinterface.GKProcessCommand("prompt \'msg \""..substitute_vars("%target%").."\" \'")
end

function quickreply:replysector()
	if last_sector_name == nil then print('\127ffffffno one has used sector chat')
	else gkinterface.GKProcessCommand("prompt \'msg \""..last_sector_name.."\" \'") end
end

function quickreply:replychannel()
	if last_chat_name == nil then print('\127ffffffno one has chatted to '..quickreply.channel)
	else gkinterface.GKProcessCommand("prompt \'msg \""..last_chat_name.."\" \'") end
end

function quickreply:recentchannel()
	if recent_channel and recent_channel ~= GetActiveChatChannel() then JoinChannel{recent_channel} end
end

function quickreply.input(args)
	if args == nil then
		quickreply.help()
	elseif args[1]:lower() == 'setch' then
		if args[2] == nil then
			print('\127ffffffYou must specify a channel, currently monitoring '..quickreply.channel)
		else
			quickreply.channel = tonumber(args[2])
			print('\127ffffffQuickReply monitoring channel '..quickreply.channel)
			gkini.WriteInt("QuickReply", "channel", quickreply.channel)
		end
	else quickreply.help() end
end

function quickreply.help()
	print('\127ffffff'..'QuickReply v'..quickreply.version..' commands are:'..
	'\n\t/quickreply setch \1270000ffnumber\127o - sets channel monitored to \1270000ffnumber\127o'..
	'\n\t/reply_target - Send a PM to current target'..
	'\n\t/reply_sector - Send a PM to the last person to use sector chat'..
	'\n\t/reply_channel - Send a PM to the last person to chat to the monitored channel'..
	'\n\t/recent_channel - Switch to the non-active channel with the most recent activity')
end

RegisterEvent(quickreply, "CHAT_MSG_CHANNEL")
RegisterEvent(quickreply, "CHAT_MSG_CHANNEL_ACTIVE")
RegisterEvent(quickreply, "CHAT_MSG_SECTOR")
RegisterEvent(quickreply, "CHAT_MSG_SECTOR_EMOTE")
RegisterUserCommand("quickreply", function(data, args) quickreply.input(args) end)
RegisterUserCommand("reply_target", quickreply.replytarget)
RegisterUserCommand("reply_sector", quickreply.replysector)
RegisterUserCommand("reply_channel", quickreply.replychannel)
RegisterUserCommand("recent_channel", quickreply.recentchannel)